diff -Naur linux-2.4.2-orig/drivers/usb/ov511.c linux/drivers/usb/ov511.c
--- linux-2.4.2-orig/drivers/usb/ov511.c	Fri Mar  2 03:21:10 2001
+++ linux/drivers/usb/ov511.c	Tue Mar 27 22:24:30 2001
@@ -3146,79 +5955,231 @@
 		return -EBUSY;
 	}
 
-	if (ov511_write_regvals(dev, aRegvalsInit)) goto error;
+	if (ov511_write_regvals(dev, aRegvalsInit511)) goto error;
+
+	if (ov511->led_policy == LED_OFF || ov511->led_policy == LED_AUTO)
+		ov511_led_control(ov511, 0);
+
 	if (ov511_write_regvals(dev, aRegvalsNorm511)) goto error;
+	if (compress) {
+		ov511_reg_write(dev, 0x70, phy);
+		ov511_reg_write(dev, 0x71, phuv);
+		ov511_reg_write(dev, 0x72, pvy);
+		ov511_reg_write(dev, 0x73, pvuv);
+		ov511_reg_write(dev, 0x74, qhy);
+		ov511_reg_write(dev, 0x75, qhuv);
+		ov511_reg_write(dev, 0x76, qvy);
+		ov511_reg_write(dev, 0x77, qvuv);
+		if (ov511_upload_quan_tables(dev) < 0)
+			err("Error uploading quantization tables");
+	}
 
 	ov511_set_packet_size(ov511, 0);
 
 	ov511->snap_enabled = snapshot;	
 
-	/* Test for 76xx */
-	if (ov511_reg_write(dev, OV511_REG_I2C_SLAVE_ID_WRITE,
-	                   OV7610_I2C_WRITE_ID) < 0)
-		goto error;
+	/* Test for 7xx0 */
+	if (ov51x_set_slave_ids(ov511, OV7xx0_I2C_WRITE_ID,
+				OV7xx0_I2C_READ_ID) < 0)
+		return -1;
 
-	if (ov511_reg_write(dev, OV511_REG_I2C_SLAVE_ID_READ,
-	                   OV7610_I2C_READ_ID) < 0)
-		goto error;
+	if (ov511_i2c_write(dev, 0x12, 0x80) < 0) {
+		/* Test for 6xx0 */
+		if (ov51x_set_slave_ids(ov511, OV6xx0_I2C_WRITE_ID,
+					OV6xx0_I2C_READ_ID) < 0)
+			return -1;
+
+		if (ov511_i2c_write(dev, 0x12, 0x80) < 0) {
+			/* Test for 8xx0 */
+			if (ov51x_set_slave_ids(ov511, OV8xx0_I2C_WRITE_ID,
+						OV8xx0_I2C_READ_ID))
+				return -1;
+
+			if (ov511_i2c_write(dev, 0x12, 0x80) < 0) {
+				err("Can't determine sensor slave IDs");
+ 				goto error;
+			} else {
+				err("Detected unsupported OV8xx0 sensor");
+				goto error;
+			}
+		} else {
+			if(ov6xx0_configure(ov511) < 0) {
+				err("failed to configure OV6xx0");
+ 				goto error;
+			}
+		}
+	} else {
+		if(ov7xx0_configure(ov511) < 0) {
+			err("failed to configure OV7xx0");
+	 		goto error;
+		}
+	}
 
-	if (ov511_reset(dev, OV511_RESET_NOREGS) < 0)
+	if (ov51x_set_default_params(ov511) < 0)
 		goto error;
 
-	if (ov511_i2c_write(dev, 0x12, 0x80) < 0) {
-		/* Test for 6xx0 */
-		if (ov511_reg_write(dev, OV511_REG_I2C_SLAVE_ID_WRITE,
-		                    OV6xx0_I2C_WRITE_ID) < 0)
-			goto error;
+	return 0;
 
-		if (ov511_reg_write(dev, OV511_REG_I2C_SLAVE_ID_READ,
-		                    OV6xx0_I2C_READ_ID) < 0)
-			goto error;
+error:
+	err("OV511 Config failed");
 
-		if (ov511_reset(dev, OV511_RESET_NOREGS) < 0)
-			goto error;
+	#if defined(CONFIG_PROC_FS) && defined(CONFIG_VIDEO_PROC_FS)
+	/* Safe to call even if entry doesn't exist */
+	destroy_proc_ov511_cam((struct usb_ov511 *)dev);
+	#endif
 
-		if (ov511_i2c_write(dev, 0x12, 0x80) < 0) {
-			err("Can't determine sensor slave IDs");
-			goto error;
-		}
-		
-		if(ov6xx0_configure(ov511) < 0) {
-			err("failed to configure OV6xx0");
- 			goto error;
+	video_unregister_device(&ov511->vdev);
+	usb_driver_release_interface(&ov511_driver,
+		&dev->actconfig->interface[ov511->iface]);
+
+	return -EBUSY;
+}
+
+/* This initializes the OV518/OV518+ and the sensor */
+static int ov518_configure(struct usb_ov511 *ov511)
+{
+	struct usb_device *dev = ov511->dev;
+	int i;
+
+	static struct ov511_regvals aRegvalsInit518[] = {
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_RESET, 0x40 },
+	 	{ OV511_REG_BUS, OV511_REG_SYSTEM_INIT, 0xe1 },
+	 	{ OV511_REG_BUS, OV511_REG_SYSTEM_RESET, 0x3e },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_INIT, 0xe1 },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_RESET, 0x00 },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_INIT, 0xe1 },
+		{ OV511_REG_BUS, 0x5d, 0x03 },
+		{ OV511_DONE_BUS, 0x0, 0x00},
+	};
+
+#if 0
+	/* Old sequence - Note: the mnemonics for these registers may not be
+	 * right with the OV518, but their values are right. */
+	static struct ov511_regvals aRegvalsNorm518[] = {
+		{ OV511_REG_BUS, OV511_REG_DRAM_ENABLE_FLOW_CONTROL, 0x09 },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_SNAPSHOT, 0x02 },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_SNAPSHOT, 0x00 },
+		{ OV511_REG_BUS, OV511_REG_FIFO_BITMASK, 0x0f },
+		{ OV511_REG_BUS, 0x24, 0x9f },
+		{ OV511_REG_BUS, 0x25, 0x90 },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_CLOCK_DIVISOR, 0x04 }, /* ? */
+		{ OV511_REG_BUS, OV511_OMNICE_ENABLE, 0x00 },
+		{ OV511_REG_BUS, OV511_OMNICE_LUT_ENABLE, 0x00 },
+		{ OV511_DONE_BUS, 0x0, 0x00 },
+	};
+#else
+	/* New values, based on Windows driver. Since what they do is not
+	 * known yet, this may be incorrect. */
+	static struct ov511_regvals aRegvalsNorm518[] = {
+		{ OV511_REG_BUS, 0x52, 0x02 },
+		{ OV511_REG_BUS, 0x52, 0x01 },
+		{ OV511_REG_BUS, 0x31, 0x0f },
+		{ OV511_REG_BUS, 0x5d, 0x03 },
+		{ OV511_REG_BUS, 0x24, 0x9f },
+		{ OV511_REG_BUS, 0x25, 0x90 },
+		{ OV511_REG_BUS, 0x20, 0x08 },
+		{ OV511_REG_BUS, 0x51, 0x04 },
+//		{ OV511_REG_BUS, 0x71, 0x19 },
+		{ OV511_DONE_BUS, 0x0, 0x00 },
+	};
+#endif
+	PDEBUG(4, "");
+
+	/* First 5 bits of custom ID reg are a revision ID on OV518 */
+	info("Camera revision %d", 0x1F & ov511_reg_read(dev, OV511_REG_SYSTEM_CUSTOM_ID));
+
+	memcpy(&ov511->vdev, &ov511_template, sizeof(ov511_template));
+
+	for (i = 0; i < OV511_NUMFRAMES; i++)
+		init_waitqueue_head(&ov511->frame[i].wq);
+
+	init_waitqueue_head(&ov511->wq);
+
+	if (video_register_device(&ov511->vdev, VFL_TYPE_GRABBER) < 0) {
+		err("video_register_device failed");
+		return -EBUSY;
+	}
+
+	if (ov511_write_regvals(dev, aRegvalsInit518)) goto error;
+
+	/* LED is off by default with OV518; have to explicitly turn it on */
+	if (ov511->led_policy == LED_OFF || ov511->led_policy == LED_AUTO)
+		ov511_led_control(ov511, 0);
+	else
+		ov511_led_control(ov511, 1);
+
+	if (compress) {
+		compress = 0;
+		warn("Compression disabled on OV518+");
+	}
+
+	if (ov511_write_regvals(dev, aRegvalsNorm518)) goto error;
+	/* The next setting may not be necessary */
+	if (ov511_reg_write_mask(dev, 0x57,0x00, 0x02) < 0) goto error;
+
+	ov511_set_packet_size(ov511, 0);
+
+	ov511->snap_enabled = snapshot;
+
+	/* Test for 76xx */
+	if (ov51x_set_slave_ids(ov511, OV7xx0_I2C_WRITE_ID,
+				OV7xx0_I2C_READ_ID) < 0)
+		return -1;
+
+	/* The OV518 must be more aggressive about sensor detection since
+	 * I2C write will never fail if the sensor is not present. We have
+	 * to try to initialize the sensor to detect its presence */
+
+	if (ov51x_init_ov_sensor(ov511) < 0) {
+		/* Test for 6xx0 */
+		if (ov51x_set_slave_ids(ov511, OV6xx0_I2C_WRITE_ID,
+					OV6xx0_I2C_READ_ID) < 0)
+			return -1;
+
+		if (ov51x_init_ov_sensor(ov511) < 0) {
+			/* Test for 8xx0 */
+			if (ov51x_set_slave_ids(ov511, OV6xx0_I2C_WRITE_ID,
+						OV6xx0_I2C_READ_ID) < 0)
+				return -1;
+
+			if (ov51x_init_ov_sensor(ov511) < 0) {
+				err("Can't determine sensor slave IDs");
+ 				goto error;
+			} else {
+				err("Detected unsupported OV8xx0 sensor");
+				goto error;
+			}
+		} else {
+			if(ov6xx0_configure(ov511) < 0) {
+				err("failed to configure OV6xx0");
+ 				goto error;
+			}
 		}
 	} else {
-		if(ov76xx_configure(ov511) < 0) {
-			err("failed to configure OV76xx");
+		if(ov7xx0_configure(ov511) < 0) {
+			err("failed to configure OV7xx0");
 	 		goto error;
 		}
 	}
-	
-	/* Set default sizes in case IOCTL (VIDIOCMCAPTURE) is not used
-	 * (using read() instead). */
-	for (i = 0; i < OV511_NUMFRAMES; i++) {
-		ov511->frame[i].width = ov511->maxwidth;
-		ov511->frame[i].height = ov511->maxheight;
-		ov511->frame[i].depth = 24;
-		ov511->frame[i].bytes_read = 0;
-		ov511->frame[i].segment = 0;
-		ov511->frame[i].format = VIDEO_PALETTE_RGB24;
-		ov511->frame[i].segsize = GET_SEGSIZE(ov511->frame[i].format);
-	}
 
-	/* Initialize to max width/height, RGB24 */
-	if (ov511_mode_init_regs(ov511, ov511->maxwidth, ov511->maxheight,
-				 VIDEO_PALETTE_RGB24, 0) < 0)
+	if (ov51x_set_default_params(ov511) < 0)
 		goto error;
 
 	return 0;
-	
+
 error:
+	err("OV518 Config failed");
+
+	#if defined(CONFIG_PROC_FS) && defined(CONFIG_VIDEO_PROC_FS)
+	/* Safe to call even if entry doesn't exist */
+	destroy_proc_ov511_cam((struct usb_ov511 *)dev);
+	#endif
+
 	video_unregister_device(&ov511->vdev);
 	usb_driver_release_interface(&ov511_driver,
 		&dev->actconfig->interface[ov511->iface]);
 
-	return -EBUSY;	
+	return -EBUSY;
 }
 
 
@@ -3234,7 +6195,6 @@
 {
 	struct usb_interface_descriptor *interface;
 	struct usb_ov511 *ov511;
-	int i;
 
 	PDEBUG(1, "probing for device...");
 
@@ -3262,6 +6222,7 @@
 
 	ov511->dev = dev;
 	ov511->iface = interface->bInterfaceNumber;
+	ov511->led_policy = led;
 
 	switch (dev->descriptor.idProduct) {
 	case 0x0511:
@@ -3272,6 +6233,10 @@
 		info("USB OV511+ camera found");
 		ov511->bridge = BRG_OV511PLUS;
 		break;
+	case 0x0518:
+		info("USB OV518+ camera found");
+		ov511->bridge = BRG_OV518PLUS;
+		break;
 	case 0x0002:
 		if (dev->descriptor.idVendor != 0x0813)
 			goto error;
@@ -3279,57 +6244,40 @@
 		ov511->bridge = BRG_OV511PLUS;
 		break;
 	default:
-		err("Unknown product ID");
-		goto error;
-	}
-
-	ov511->customid = ov511_reg_read(dev, OV511_REG_SYSTEM_CUSTOM_ID);
-	if (ov511->customid < 0) {
-		err("Unable to read camera bridge registers");
-		goto error;
-	}
-
-	ov511->desc = -1;
-	PDEBUG (4, "CustomID = %d", ov511->customid);
-	for (i = 0; clist[i].id >= 0; i++) {
-		if (ov511->customid == clist[i].id) {
-			info("camera: %s", clist[i].description);
-			ov511->desc = i;
-			break;
-		}
-	}
-
-	/* Lifeview USB Life TV not supported */
-	if (clist[i].id == 38) {
-		err("This device is not supported yet.");
+		err("Unknown product ID 0x%x", dev->descriptor.idProduct);
 		goto error;
 	}
 
-	if (clist[i].id == -1) {
-		err("Camera type (%d) not recognized", ov511->customid);
-		err("Please contact mwm@i.am to request");
-		err("support for your camera.");
-	}
-
 	/* Workaround for some applications that want data in RGB
-	 * instead of BGR */
+	 * instead of BGR. */
 	if (force_rgb)
 		info("data format set to RGB");
 
-	if (!ov511_configure(ov511)) {
-		ov511->user = 0;
-		init_MUTEX(&ov511->lock);	/* to 1 == available */
-		init_MUTEX(&ov511->buf_lock);
-		ov511->buf_state = BUF_NOT_ALLOCATED;
+	if (ov511->bridge == BRG_OV518PLUS) {
+		if (ov518_configure(ov511) < 0)
+			goto error;
 	} else {
-		err("Failed to configure camera");
-		goto error;
+		if (ov511_configure(ov511) < 0)
+			goto error;
 	}
 
+	init_MUTEX(&ov511->lock);	/* to 1 == available */
+	init_MUTEX(&ov511->buf_lock);
+	init_MUTEX(&ov511->param_lock);
+	ov511->buf_state = BUF_NOT_ALLOCATED;
+
+#ifdef OV511_DEBUG
+	if (dump_bridge)
+		ov511_dump_regs(dev);
+#endif
+
+	PDEBUG(1, "Camera initialization successful");
+
 	MOD_DEC_USE_COUNT;
      	return ov511;
 
 error:
+	err("Camera initialization failed");
 	if (ov511) {
 		kfree(ov511);
 		ov511 = NULL;
@@ -3433,7 +6381,7 @@
 
 #if defined(CONFIG_PROC_FS) && defined(CONFIG_VIDEO_PROC_FS)
         proc_ov511_destroy();
-#endif 
+#endif
 }
 
 module_init(usb_ov511_init);
diff -Naur linux-2.4.2-orig/drivers/usb/ov511.h linux/drivers/usb/ov511.h
--- linux-2.4.2-orig/drivers/usb/ov511.h	Fri Mar  2 03:21:10 2001
+++ linux/drivers/usb/ov511.h	Tue Mar 27 22:24:31 2001
@@ -15,6 +15,40 @@
 #  define PDEBUG(level, fmt, args...) do {} while(0)
 #endif
 
+/* Standard Windows data types, taken from winnt.h at 
+ * http://www.winehq.com/wine/include/ */
+
+#ifndef VOID
+#define VOID void
+#endif
+
+typedef const void			*PCVOID,	*LPCVOID;
+typedef int		BOOL,		*PBOOL,		*LPBOOL;
+typedef unsigned char	BYTE,		*PBYTE,		*LPBYTE;
+typedef unsigned char	UCHAR,		*PUCHAR;
+typedef unsigned short	USHORT,		*PUSHORT,	*LPUSHORT;
+typedef unsigned short	WORD,		*PWORD,		*LPWORD;
+typedef int		INT,		*PINT,		*LPINT;
+typedef unsigned int	UINT,		*PUINT,		*LPUINT;
+typedef unsigned long	DWORD,		*PDWORD,	*LPDWORD;
+typedef unsigned long	ULONG,		*PULONG,	*LPULONG;
+typedef VOID		*PVOID,		*LPVOID;
+typedef BYTE		BOOLEAN,	*PBOOLEAN;
+typedef char		CHAR,		*PCHAR;
+typedef short		SHORT,		*PSHORT;
+typedef long		LONG,		*PLONG,		*LPLONG;
+typedef __s64		LONGLONG,	*PLONGLONG;
+typedef __u64		ULONGLONG,	*PULONGLONG;
+typedef ULONGLONG	DWORDLONG,	*PDWORDLONG;
+
+typedef ULONG		NTSTATUS;
+const NTSTATUS STATUS_SUCCESS 		= 0x00000000;
+const NTSTATUS STATUS_UNSUCCESSFUL 	= 0xC0000001;
+
+/* --------------------------------- */
+/* DEFINES FOR OV511 AND OTHER CHIPS */
+/* --------------------------------- */
+
 /* Camera interface register numbers */
 #define OV511_REG_CAMERA_DELAY_MODE		0x10
 #define OV511_REG_CAMERA_EDGE_MODE		0x11
@@ -52,6 +86,7 @@
 
 /* I2C register numbers */
 #define OV511_REG_I2C_CONTROL			0x40
+#define OV518_REG_I2C_CONTROL			0x47	/* OV518+ only */
 #define OV511_REG_I2C_SLAVE_ID_WRITE		0x41
 #define OV511_REG_I2C_SUB_ADDRESS_3_BYTE	0x42
 #define OV511_REG_I2C_SUB_ADDRESS_2_BYTE	0x43
@@ -78,8 +113,16 @@
 #define OV511_REG_SYSTEM_CLOCK_DIVISOR		0x51
 #define OV511_REG_SYSTEM_SNAPSHOT		0x52
 #define OV511_REG_SYSTEM_INIT         		0x53
-#define OV511_REG_SYSTEM_PWR_CLK		0x54	/* OV511+ only */
+#define OV511_REG_SYSTEM_PWR_CLK		0x54	/* OV511+/OV518+ only */
 #define OV511_REG_SYSTEM_LED_CTL		0x55	/* OV511+ only */
+#define OV518_REG_GPIO_IN			0x55	/* OV518+ only */
+#define OV518_REG_GPIO_OUT			0x56	/* OV518+ only */
+#define OV518_REG_GPIO_CTL			0x57	/* OV518+ only */
+#define OV518_REG_GPIO_PULSE_IN			0x58	/* OV518+ only */
+#define OV518_REG_GPIO_PULSE_CLEAR		0x59	/* OV518+ only */
+#define OV518_REG_GPIO_PULSE_POLARITY		0x5a	/* OV518+ only */
+#define OV518_REG_GPIO_PULSE_EN			0x5b	/* OV518+ only */
+#define OV518_REG_GPIO_RESET			0x5c	/* OV518+ only */
 #define OV511_REG_SYSTEM_USER_DEFINED		0x5E
 #define OV511_REG_SYSTEM_CUSTOM_ID		0x5F
 
@@ -119,6 +162,16 @@
 #define OV511PLUS_ALT_SIZE_769	6
 #define OV511PLUS_ALT_SIZE_961	7
 
+/* Alternate numbers for various max packet sizes (OV518+ only) */
+#define OV518PLUS_ALT_SIZE_0	0
+#define OV518PLUS_ALT_SIZE_128	1
+#define OV518PLUS_ALT_SIZE_256	2
+#define OV518PLUS_ALT_SIZE_384	3
+#define OV518PLUS_ALT_SIZE_512	4
+#define OV518PLUS_ALT_SIZE_640	5
+#define OV518PLUS_ALT_SIZE_768	6
+#define OV518PLUS_ALT_SIZE_896	7
+
 /* OV7610 registers */
 #define OV7610_REG_GAIN          0x00	/* gain setting (5:0) */
 #define OV7610_REG_BLUE          0x01	/* blue channel balance */
@@ -176,15 +229,17 @@
 #define FRAMES_PER_DESC		10	/* FIXME - What should this be? */
 #define FRAME_SIZE_PER_DESC	993	/* FIXME - Deprecated */
 #define MAX_FRAME_SIZE_PER_DESC	993	/* For statically allocated stuff */
+#define PIXELS_PER_SEG		256	/* Pixels per segment */
 
 #define OV511_ENDPOINT_ADDRESS 1	/* Isoc endpoint number */
 
-// CAMERA SPECIFIC
-// FIXME - these can vary between specific models
-#define OV7610_I2C_WRITE_ID 0x42
-#define OV7610_I2C_READ_ID  0x43
+/* CAMERA SPECIFIC */
+#define OV7xx0_I2C_WRITE_ID 0x42
+#define OV7xx0_I2C_READ_ID  0x43
 #define OV6xx0_I2C_WRITE_ID 0xC0
 #define OV6xx0_I2C_READ_ID  0xC1
+#define OV8xx0_I2C_WRITE_ID 0xA0
+#define OV8xx0_I2C_READ_ID  0xA1
 
 #define OV511_I2C_CLOCK_PRESCALER 0x03
 
@@ -196,17 +251,22 @@
 
 /* Bridge types */
 enum {
+	BRG_UNKNOWN,
 	BRG_OV511,
 	BRG_OV511PLUS,
+	BRG_OV518PLUS,
 };
 
-/* Sensor types */
+/* Sensor types - Update ov511.txt (sensor param docs) if you change this! */
 enum {
 	SEN_UNKNOWN,
 	SEN_OV7610,
 	SEN_OV7620,
 	SEN_OV7620AE,
 	SEN_OV6620,
+	SEN_OV6630,
+	SEN_OV8600,
+	SEN_KS0127,
 };
 
 enum {
@@ -222,6 +282,19 @@
 	BUF_PEND_DEALLOC,	/* ov511->buf_timer is set */
 };
 
+/* LED options */
+enum {
+	LED_OFF,
+	LED_ON,
+	LED_AUTO,
+};
+
+/* Keeps track of where we are in decompressing a frame */
+typedef struct CompInfo {
+	LONG index;
+	DWORD IPTRR_U;
+} CompInfo;
+
 struct usb_device;
 
 struct ov511_sbuf {
@@ -249,6 +322,7 @@
 
 struct ov511_frame {
 	char *data;		/* Frame buffer */
+	char *rawdata;		/* Raw camera data buffer */
 
 	int depth;		/* Bytes per pixel */
 	int width;		/* Width application is expecting */
@@ -259,6 +333,7 @@
 
 	int sub_flag;		/* Sub-capture mode for this frame? */
 	unsigned int format;	/* Format for this frame */
+	int compressed;		/* Is frame compressed? */
 	int segsize;		/* How big is each segment from the camera? */
 
 	volatile int grabstate;	/* State of grabbing */
@@ -267,9 +342,15 @@
 	int curline;		/* Line of frame we're working on */
 	int curpix;
 	int segment;		/* Segment from the incoming data */
+	int bytes_recvd;	/* Number of image bytes received from camera */
 
 	long scanlength;	/* uncompressed, raw data length of frame */
 	long bytes_read;	/* amount of scanlength that has been read from *data */
+	int output_offset;	/* Current offset where we are dumping raw data */
+
+	CompInfo TempInfo;	/* Keeps track of decompression state */
+	PUCHAR m_pTempBuffer;	/* Temporary buffer, used by decompressor */
+	ULONG m_TempBufferLength;
 
 	wait_queue_head_t wq;	/* Processes waiting */
 
@@ -299,6 +380,8 @@
 	int hue;
 	int whiteness;
 
+	int led_policy;		/* LED: off|on|auto; OV511+ only */
+
 	struct semaphore lock;
 	int user;		/* user count for exclusive use */
 
@@ -308,6 +391,7 @@
 	int compress;		/* Should the next frame be compressed? */
 
 	char *fbuf;		/* Videodev buffer area */
+	char *rawfbuf;		/* Raw camera data buffer area */
 
 	int sub_flag;		/* Pix Array subcapture on flag */
 	int subx;		/* Pix Array subcapture x offset */
@@ -334,10 +418,14 @@
 
 	int packet_size;	/* Frame size per isoc desc */
 
-				/* proc interface */
 	struct semaphore param_lock;	/* params lock for this camera */
-	struct proc_dir_entry *proc_entry;	/* /proc/ov511/videoX */
-	
+
+	/* /proc entries, relative to /proc/video/ov511/ */
+	struct proc_dir_entry *proc_devdir;   /* Per-device proc directory */
+	struct proc_dir_entry *proc_info;     /* <minor#>/info entry */
+	struct proc_dir_entry *proc_button;   /* <minor#>/button entry */
+	struct proc_dir_entry *proc_control;  /* <minor#>/control entry */
+
 	/* Framebuffer/sbuf management */
 	int buf_state;
 	struct semaphore buf_lock;
@@ -354,7 +442,7 @@
 	char *name;
 };
 
-struct mode_list {
+struct mode_list_511 {
 	int width;
 	int height;
 	int color;		/* 0=grayscale, 1=color */
@@ -366,6 +454,92 @@
 	u8 common_A;
 	u8 common_L;
 };
+
+struct mode_list_518 {
+	int width;
+	int height;
+	u8 reg28;
+	u8 reg29;
+	u8 reg2a;
+	u8 reg2c;
+	u8 reg2e;
+	u8 reg24;
+	u8 reg25;
+};
+
+/* Compression stuff */
+
+#define QUANTABLESIZE	64
+#define IDCTTABLESIZE	256
+#define ZIGZAGTABLESIZE	64
+
+#define YQUANTABLE { \
+	0,  1,  1,  2,  2,  3,  3,  4, \
+	1,  1,  1,  2,  2,  3,  4,  4, \
+	1,  1,  2,  2,  3,  4,  4,  4, \
+	2,  2,  2,  3,  4,  4,  4,  4, \
+	2,  2,  3,  4,  4,  5,  5,  5, \
+	3,  3,  4,  4,  5,  5,  5,  5, \
+	3,  4,  4,  4,  5,  5,  5,  5, \
+	4,  4,  4,  4,  5,  5,  5,  5  \
+}
+
+#define UVQUANTABLE { \
+	0,  2,  2,  3,  4,  4,  4,  4, \
+	2,  2,  2,  4,  4,  4,  4,  4, \
+	2,  2,  3,  4,  4,  4,  4,  4, \
+	3,  4,  4,  4,  4,  4,  4,  4, \
+	4,  4,  4,  4,  4,  4,  4,  4, \
+	4,  4,  4,  4,  4,  4,  4,  4, \
+	4,  4,  4,  4,  4,  4,  4,  4, \
+	4,  4,  4,  4,  4,  4,  4,  4  \
+}
+
+#define IDCTTABLE { \
+	 11584,  11584,  11584,  11584,	    16708,  16708,  16708,  16708, \
+	 17696,  17696,  17696,  17696,	    13640,  13640,  13640,  13640, \
+	 11584,  11584,  11584,  11584,	     9360,   9360,   9360,   9360, \
+	  6274,   6274,   6274,   6274,	     3204,   3204,   3204,   3204, \
+	 11584,  11584,  11584,  11584,	    13640,  13640,  13640,  13640, \
+	  6274,   6274,   6274,   6274,	    -3204,  -3204,  -3204,  -3204, \
+	-11584, -11584, -11584, -11584,    -16708, -16708, -16708, -16708, \
+	-17696, -17696, -17696, -17696,     -9360,  -9360,  -9360,  -9360, \
+	 11584,  11584,  11584,  11584,      9360,   9360,   9360,   9360, \
+	 -6274,  -6274,  -6274,  -6274,    -16708, -16708, -16708, -16708, \
+	-11584, -11584, -11584, -11584,      3204,   3204,   3204,   3204, \
+	 17696,  17696,  17696,  17696,     13640,  13640,  13640,  13640, \
+	 11584,  11584,  11584,  11584,      3204,   3204,   3204,   3204, \
+	-17696, -17696, -17696, -17696,     -9360,  -9360,  -9360,  -9360, \
+	 11584,  11584,  11584,  11584,     13640,  13640,  13640,  13640, \
+	 -6274,  -6274,  -6274,  -6274,    -16708, -16708, -16708, -16708, \
+	 11584,  11584,  11584,  11584,     -3204,  -3204,  -3204,  -3204, \
+	-17696, -17696, -17696, -17696,      9360,   9360,   9360,   9360, \
+	 11584,  11584,  11584,  11584,    -13640, -13640, -13640, -13640, \
+	 -6274,  -6274,  -6274,  -6274,     16708,  16708,  16708,  16708, \
+	 11584,  11584,  11584,  11584,     -9360,  -9360,  -9360,  -9360, \
+	 -6274,  -6274,  -6274,  -6274,     16708,  16708,  16708,  16708, \
+	-11584, -11584, -11584, -11584,     -3204,  -3204,  -3204,  -3204, \
+	 17696,  17696,  17696,  17696,    -13640, -13640, -13640, -13640, \
+	 11584,  11584,  11584,  11584,    -13640, -13640, -13640, -13640, \
+	  6274,   6274,   6274,   6274,      3204,   3204,   3204,   3204, \
+	-11584, -11584, -11584, -11584,     16708,  16708,  16708,  16708, \
+	-17696, -17696, -17696, -17696,      9360,   9360,   9360,   9360, \
+	 11584,  11584,  11584,  11584,    -16708, -16708, -16708, -16708, \
+	 17696,  17696,  17696,  17696,    -13640, -13640, -13640, -13640, \
+	 11584,  11584,  11584,  11584,     -9360,  -9360,  -9360,  -9360, \
+	  6274,   6274,   6274,   6274,     -3204,  -3204,  -3204,  -3204  \
+}
+
+#define ZIGZAGTABLE { \
+	  0,   2,  16,  32,  18,   4,   6,  20, \
+	 34,  48,  64,  50,  36,  22,   8,  10, \
+	 24,  38,  52,  66,  80,  96,  82,  68, \
+	 54,  40,  26,  12,  14,  28,  42,  56, \
+	 70,  84,  98, 112, 114, 100,  86,  72, \
+	 58,  44,  30,  46,  60,  74,  88, 102, \
+	116, 118, 104,  90,  76,  62,  78,  92, \
+	106, 120, 122, 108,  94, 110, 124, 126  \
+}
 
 #endif
 
